Index: testsuites/psxtmtests/Makefile.am
===================================================================
--- testsuites/psxtmtests/Makefile.am	(revision 2d6543d4c84cc896b7ff357772ea02472d49d882)
+++ testsuites/psxtmtests/Makefile.am	(revision 7de5ef5f83b21391cf0fdd35ffb404705643776c)
@@ -7,4 +7,5 @@
 SUBDIRS += psxtmbarrier02
 SUBDIRS += psxtmbarrier03
+SUBDIRS += psxtmbarrier04
 SUBDIRS += psxtmcond01
 SUBDIRS += psxtmcond02
Index: testsuites/psxtmtests/configure.ac
===================================================================
--- testsuites/psxtmtests/configure.ac	(revision 2d6543d4c84cc896b7ff357772ea02472d49d882)
+++ testsuites/psxtmtests/configure.ac	(revision 7de5ef5f83b21391cf0fdd35ffb404705643776c)
@@ -81,4 +81,5 @@
 psxtmbarrier02/Makefile
 psxtmbarrier03/Makefile
+psxtmbarrier04/Makefile
 psxtmcond01/Makefile
 psxtmcond02/Makefile
Index: testsuites/psxtmtests/psxtmbarrier04/Makefile.am
===================================================================
--- testsuites/psxtmtests/psxtmbarrier04/Makefile.am	(revision 7de5ef5f83b21391cf0fdd35ffb404705643776c)
+++ testsuites/psxtmtests/psxtmbarrier04/Makefile.am	(revision 7de5ef5f83b21391cf0fdd35ffb404705643776c)
@@ -0,0 +1,27 @@
+MANAGERS = all
+
+rtems_tests_PROGRAMS = psxtmbarrier04
+psxtmbarrier04_SOURCES  = init.c
+psxtmbarrier04_SOURCES += ../../tmtests/include/timesys.h
+psxtmbarrier04_SOURCES += ../../support/src/tmtests_empty_function.c
+psxtmbarrier04_SOURCES += ../../support/src/tmtests_support.c
+
+dist_rtems_tests_DATA = psxtmbarrier04.doc
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
+
+OPERATION_COUNT = @OPERATION_COUNT@
+AM_CPPFLAGS += -I$(top_srcdir)/../tmtests/include
+AM_CPPFLAGS += -DOPERATION_COUNT=$(OPERATION_COUNT)
+AM_CPPFLAGS += -I$(top_srcdir)/../support/include
+
+LINK_OBJS = $(psxtmbarrier04_OBJECTS) $(psxtmbarrier04_LDADD)
+LINK_LIBS = $(psxtmbarrier04_LDLIBS)
+
+psxtmbarrier04$(EXEEXT): $(psxtmbarrier04_OBJECTS) $(psxtmbarrier04_DEPENDENCIES)
+	@rm -f psxtmbarrier04$(EXEEXT)
+	$(make-exe)
+
+include $(top_srcdir)/../automake/local.am
Index: testsuites/psxtmtests/psxtmbarrier04/init.c
===================================================================
--- testsuites/psxtmtests/psxtmbarrier04/init.c	(revision 7de5ef5f83b21391cf0fdd35ffb404705643776c)
+++ testsuites/psxtmtests/psxtmbarrier04/init.c	(revision 7de5ef5f83b21391cf0fdd35ffb404705643776c)
@@ -0,0 +1,94 @@
+/*
+ *  COPYRIGHT (c) 1989-2013.
+ *  On-Line Applications Research Corporation (OAR).
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+#include <tmacros.h>
+#include <timesys.h>
+#include "test_support.h"
+#include <pthread.h>
+#include <sched.h>
+#include <rtems/timerdrv.h>
+
+/* forward declarations to avoid warnings */
+void *POSIX_Init(void *argument);
+void *Blocker(void *argument);
+
+#define N  2
+pthread_barrier_t     barrier;
+
+void *Blocker(
+  void *argument
+)
+{
+  benchmark_timer_t end_time;
+
+  /* block on barrier wait, switch back to first thread */
+  (void) pthread_barrier_wait( &barrier );
+
+
+  /* preempt first thread and stop time */
+  end_time = benchmark_timer_read();
+  put_time(
+    "pthread_barrier_wait â releasing, preempt",
+    end_time,
+    1,
+    0,
+    0
+  );
+  puts( "*** END OF POSIX TIME TEST PSXTMBARRIER 04 ***" );
+  rtems_test_exit( 0 );
+
+}
+
+void *POSIX_Init(
+  void *argument
+)
+{
+  int        status;
+  pthread_t  threadId;
+  int policy;
+  struct sched_param param;
+
+  puts( "\n\n*** POSIX TIME TEST PSXTMBARRIER 04 ***" );
+
+  status = pthread_create( &threadId, NULL, Blocker, NULL );
+  rtems_test_assert( status == 0 );
+  status = pthread_barrier_init( &barrier, NULL, N );
+  rtems_test_assert( status == 0 );
+
+  /* yield to second thread so it can start up and block */
+  sched_yield();
+
+  pthread_getschedparam(threadId, &policy, &param);
+  param.sched_priority = sched_get_priority_max(policy) - 1;
+  /* preempt doesn't occur here due to second thread being blocked */
+  pthread_setschedparam(threadId, policy, &param);
+
+  /* as soon as this thread waits on barrier, release occurs, 2nd thread
+   * preempts this one due to having a higher priority
+   */
+  benchmark_timer_initialize();
+  status = pthread_barrier_wait( &barrier );
+}
+
+/* configuration information */
+
+#define CONFIGURE_APPLICATION_NEEDS_CONSOLE_DRIVER
+#define CONFIGURE_APPLICATION_NEEDS_TIMER_DRIVER
+
+#define CONFIGURE_MAXIMUM_POSIX_THREADS     2
+#define CONFIGURE_MAXIMUM_POSIX_BARRIERS    1
+#define CONFIGURE_POSIX_INIT_THREAD_TABLE
+
+#define CONFIGURE_INIT
+
+#include <rtems/confdefs.h>
+/* end of file */
Index: testsuites/psxtmtests/psxtmtests_plan.csv
===================================================================
--- testsuites/psxtmtests/psxtmtests_plan.csv	(revision 2d6543d4c84cc896b7ff357772ea02472d49d882)
+++ testsuites/psxtmtests/psxtmtests_plan.csv	(revision 7de5ef5f83b21391cf0fdd35ffb404705643776c)
@@ -60,5 +60,5 @@
 "pthread_barrier_wait - blocking","psxtmbarrier02","psxtmtest_blocking","Yes"
 "pthread_barrier_wait - releasing: no preempt","psxtmbarrier03","psxtmtest_unblocking_nopreempt","Yes"
-"pthread_barrier_wait - releasing: preempt","psxtmbarrier04","psxtmtest_unblocking_preempt","No"
+"pthread_barrier_wait - releasing: preempt","psxtmbarrier04","psxtmtest_unblocking_preempt","Yes"
 ,,,
 "pthread_spin_init","psxspin01","psxtmtest_init_destroy","No"
